10  '   ------------------------------------------------------------
20  '   |                          MAKEMEMO                        |
30  '   |                                                          |
40  '   |               copyright 1983    Chester Gabriel          |
50  '   ------------------------------------------------------------
60 DIM MDAY(13)
70 DIM DASH(3)
80 DIM FLAG$(128) : MAXFILES = 128
90 OPEN "R", 1, "MEMOFILE"
100 FIELD 1, 128 AS F$
110 GET 1,1
120 FOR I = 1 TO 128
130    FLAG$(I) = MID$(F$,I,1)
140 NEXT
150 IF FLAG$(1) = "I" THEN GOTO 210
160    TF$ = "I" : FLAG$(1) = "I"        ' *** Initialize data file if this is
170    FOR I = 2 TO MAXFILES		 ' *** first execution of the program.
180	  TF$ = TF$ + "E" : FLAG$(I)="E" ' ***  Set first flag to "initialized"
190    NEXT				 ' *** and all others to "empty".
200    LSET F$ = TF$ : PUT 1,1
210 FIELD 1, 79 AS MEMO$, 4 AS FIRSTDATE$, 4 AS LASTDATE$, 10 AS RAWDATE$,           1 AS FREQ$, 2 AS WINNDOW$, 3 AS INTERVAL$
220 PRINT: PRINT "SELECT OPTION:"
230 PRINT "A = ADD A NEW MEMO"
240 PRINT "D = DELETE AN EXISTING MEMO"
250 PRINT "X = EXIT FROM PROGRAM": PRINT
260 LINE INPUT "OPTION =  ? "; X$
270 GOSUB  950 : OPT$ = X$    ' *** convert any lower case letters to upper
280 IF OPT$ = "A" THEN GOSUB  390 : GOTO 320
290 IF OPT$ = "D" THEN GOSUB 1330 : GOTO 320
300 IF OPT$ = "X" THEN PRINT "PROGRAM EXITED " : GOTO 320
310 PRINT " THE ONLY OPTIONS ARE A,D, AND X. PLEASE RE-ENTER": GOTO 260
320 CLOSE
330 END
340 '
350 ' ***************************************************************
360 ' *****           SUBROUTINE TO ADD A MEMO                 ******
370 ' ***************************************************************
380 '
390 FOR R = 2 TO MAXFILES
400  IF FLAG$(R) <> "E", THEN GOTO 860           ' find first empty record
410    PRINT  "MEMO (79 CHARACTERS MAX) = "
420    PRINT : LINE INPUT TMEMO$
430    PRINT : PRINT "     MEMO FREQUENCIES:"
440    PRINT "O = ONCE"
450    PRINT "A = ALWAYS"
460    PRINT "M = MONTHLY"
470    PRINT "Y = YEARLY"
480    PRINT "E = EVERY N DAYS" : PRINT
490    PRINT "X = EXIT PROGRAM" : PRINT
500    LINE INPUT "DESIRED FREQUENCY = ", X$
510    GOSUB 950	    '  ***  convert any lower case letters to upper
520    TFREQ$ = X$
530    IF TFREQ$ = "O" THEN GOTO 630
540    IF TFREQ$ = "A" THEN GOTO 710
550    IF TFREQ$ = "M" THEN GOTO 630
560    IF TFREQ$ = "Y" THEN GOTO 630
570    IF TFREQ$ = "E" THEN GOTO 600
580    IF TFREQ$ = "X" THEN GOTO 880
590    PRINT "FREQUENCY MUST BE O,A,M,Y,E,OR X" : PRINT : GOTO 500
600    PRINT:LINE INPUT "ENTER NUMBER OF DAYS BETWEEN DISPLAYS (999 MAX): "; E$
610    IF E$ = "X" OR E$ = "x" THEN GOTO 880
620    IF VAL(E$) < 0 OR VAL(E$) > 999 THEN PRINT: PRINT "INVALID INTERVAL" :           GOTO 600
630    PRINT : LINE INPUT "ENTER DATE TO DISPLAY MEMO (MM-DD-YY):  "; D$
640    IF D$ = "X" OR D$ = "x" THEN GOTO 880
650    GOSUB 1040	' *** Convert to sequential date
660    IF DATERR <> 0 THEN PRINT "ERRONEOUS DATE; RE-ENTER " : GOTO 630
670    TLASTDATE$ = MKI$(SEQDATE)
680    PRINT : LINE INPUT "NUMBER OF DAYS WHICH  MESSAGE IS TO BE DISPLAYED:  ";          TWINDOW$
690    IF TWINDOW$ = "X" OR TWINDOW$ = "x" THEN GOTO 880       ' exit
700    TFIRSTDATE$ = MKI$( CVI(TLASTDATE$) - VAL(TWINDOW$) )
710    LSET MEMO$ = TMEMO$
720    LSET FIRSTDATE$ = TFIRSTDATE$
730    LSET LASTDATE$ = TLASTDATE$
740    LSET RAWDATE$ = D$
750    LSET FREQ$ = TFREQ$
760    LSET WINNDOW$ = TWINDOW$
770    LSET INTERVAL$ = E$
780    PUT 1,R
790    FLAG$(R) = "F"
800    FIELD 1, 128 AS F$	       '   flag record "R" as being full
810    GET 1,1
820    LSET F$ = LEFT$(F$,R-1) + "F" + RIGHT$(F$, 128-R)
830    PUT 1,1
840    PRINT : LINE INPUT "ENTER ANOTHER MEMO (Y/N)? "; YN$
850    IF YN$ = "N" OR YN$ = "n" THEN GOTO 880
860 NEXT
870 IF R>MAXFILES THEN	PRINT "MAXIMUM NUMBER OF MEMOS (127) ALREADY STORED"
880 PRINT: PRINT "MEMO ADDITION COMPLETE "
890 RETURN
900 '
910 ' ***************************************************************
920 ' *****      SUBROUTINE TO CONVERT LOWER TO UPPER CASE      *****
930 ' ***************************************************************
940 '
950 L = ASC( LEFT$(X$,1) )
960 IF L >96 AND  L < 123  THEN X$ = CHR$(L - 32)
970 RETURN
980 '
990 ' ***************************************************************
1000 ' ******    SUBROUTINE TO CONVERT DATE TO SEQUENTIAL DATE    ****
1010 ' ******           Input = D$    Output = SEQDATE            ****
1020 '***************************************************************
1030 '
1040 DATA 0,0,31,59,90,120,151,181,212,243,273,304,334
1050 RESTORE  'start reading the first data item each time subroutine entered
1060 FOR I = 0 TO 12
1070	READ MDAY(I)
1080 NEXT
1090 DATERR = 0
1100 J = 1
1110 FOR I = 1 TO LEN(D$)
1120	IF MID$(D$,I,1) = "/" OR MID$(D$,I,1)= "-" THEN DASH(J) =I :J=J+1
1130 NEXT I
1140 MO = VAL(D$)
1150 DA = VAL( MID$ (D$,DASH(1)+1) )
1160 YR = VAL( MID$ (D$,DASH(2)+1) )
1170 YR$ = RIGHT$(STR$(YR),2)
1180 YR  = VAL(YR$)
1190 IF MO < 1 OR MO > 12 THEN DATERR = 1
1200 IF DA < 1 OR DA > 31 THEN DATERR = 2
1210 IF YR < 81  THEN DATERR = 3
1220 INTVAL% = YR -80
1230 LEAPYRS% = INTVAL% / 4
1240 IF INTVAL%/4 - LEAPYRS% <> 0 THEN GOTO  1260   ' branch if not a leapyear
1250 IF  MO < 3   THEN LEAPYRS% = LEAPYRS% - 1	 'don't add a day until Mar 1
1260 SEQDATE = (INTVAL% * 365) + MDAY(MO) + DA
1270 RETURN
1280 '
1290 ' ***************************************************************
1300 ' ******           SUBROUTINE TO DELETE A MEMO             ******
1310 ' ***************************************************************
1320 '
1330 FOR R = 2 TO MAXFILES
1340  IF FLAG$(R) <> "F" THEN GOTO 1520
1350    FIELD 1, 79 AS MEMO$, 4 AS FIRSTDATE$, 4 AS LASTDATE$, 10 AS RAWDATE$,           1 AS FREQ$, 2 AS WINNDOW$, 3 AS INTERVAL$
1360	GET 1,R
1370	PRINT : PRINT : PRINT MEMO$
1380    PRINT "Frequency = ", FREQ$, "Date = "; RAWDATE$, "Window = "; WINNDOW$
1390	PRINT: LINE INPUT "DELETE THE ABOVE MEMO? (Y/N): "; YN$
1400	IF YN$ = "N" OR YN$ = "n" THEN GOTO 1520
1410	IF YN$ = "X" OR YN$ = "x" THEN GOTO 1540
1420	IF YN$ <> "Y" AND YN$ <> "y" THEN PRINT "ENTER Y OR N ": GOTO 1390
1430	FIELD 1, 128 AS F$     ' flag record "R" as now being empty
1440	GET 1,1
1450	TF$ = LEFT$(F$,R-1) + "E" + RIGHT$(F$,128-R)
1460	FLAG$(R) = "E"
1470	LSET F$ = TF$
1480	PUT 1,1
1490	PRINT : LINE INPUT "DELETE ANOTHER? (Y/N)  "; YN$
1500	IF YN$ = "N" OR YN$ = "n" OR YN$ = "X" OR YN$ = "x" THEN GOTO 1540
1510	IF YN$ <> "Y" AND YN$ <> "y" THEN PRINT "ENTER Y OR N ": GOTO 1490
1520 NEXT
1530 PRINT: PRINT "ALL MEMOS DISPLAYED"
1540 PRINT "DELETIONS COMPLETE"
1550 RETURN
1560 '
