10  '   ------------------------------------------------------------
20  '   |                       SHOWMEMO                           |
30  '   |                                                          |
40  '   |           Copyright 1983   Chester Gabriel               |
50  '   ------------------------------------------------------------
60 DIM MDAY(13)
70 DIM FLAG$(128)
80 DIM DASH(3)
90 H = 0 : M = 0 : MAXFILES = 128
100 OPEN "R", 1, "MEMOFILE"
110 FIELD 1, 128 AS F$
120 GET 1,1
130 FOR I = 1 TO 128
140    FLAG$(I) = MID$(F$,I,1)        ' read in all "full/empty" flags
150 NEXT
160 D$ = DATE$ : GOSUB 760 : TODAY = SEQDATE     ' convert to sequential date
170 FIELD 1, 79 AS MEMO$, 4 AS FIRSTDATE$, 4 AS LASTDATE$, 10 AS RAWDATE$, 1 AS      FREQ$, 2 AS WINDOWW$, 3 AS INTERVAL$
180 FOR R = 2 TO MAXFILES
190    IF FLAG$(R) <> "F" GOTO 250         ' skip empty records
200    IF H=0 THEN H = H + 1 : PRINT TAB(20);"HELLO, MR. GABRIEL.  YOUR MESSAGES ARE:"
210    GET 1,R
220    IF FREQ$ = "A" THEN PRINT : PRINT  MEMO$ : M = M + 1 : GOTO 250
230    IF TODAY > CVI(LASTDATE$) THEN GOSUB 360 : GOTO 230  ' increment date
240    IF CVI(FIRSTDATE$) <= TODAY AND TODAY <= CVI(LASTDATE$) THEN PRINT :             PRINT MEMO$ : M = M+1
250 NEXT
260 CLOSE
270 PRINT: PRINT TAB(29);
280 IF M = 0 THEN PRINT " NO MESSAGES TODAY"  ELSE PRINT " END OF MESSAGES"
290 KEY ON
300 END
310 '
320 '   ************************************************************
330 '   ***    SUBROUTINE TO INCREMENT DATES OF PERIODIC MEMOS   ***
340 '   ************************************************************
350 '
360 GET 1,R
370 D$ = RAWDATE$ : GOSUB 760           ' get values of MO, DA, YR
380 IF FREQ$ <> "O" THEN GOTO 450
390    FIELD 1, 128 AS F$         ' delete one-time memo
400    GET 1,1
410    TF$ = LEFT$(F$,R-1) + "E" + RIGHT(F$, 128-R)
420    LSET F$ = TF$ : PUT 1,1
430    FIELD 1, 79 AS MEMO$, 4 AS FIRSTDATE$, 4 AS LASTDATE$, 10 AS                     RAWDATE$, 1 AS FREQ$, 2 AS WINDOWW$, 3 AS INTERVAL$
440    GOTO 690
450 IF FREQ$ <>  "E" THEN GOTO 510
460    L = CVI(LASTDATE$) + VAL(INTERVAL$)   ' increment date of "every N days"
470    F = CVI(LASTDATE$) - VAL(WINDOW$)     ' memo
480    LSET LASTDATE$ = MKI$(L)
490    LSET FIRSTDATE$ = MKI$(F)
500    GOTO 680
510 IF FREQ$ <> "M" THEN GOTO 600
520    IF MO = 12 THEN MO = 1 : YR = YR + 1 ELSE MO = MO + 1     'increment
530    R$ = STR$(MO) + "-" + STR$(DA) + "-" + STR$(YR)           ' month
540    D$ = R$ : GOSUB  760                    '  convert to sequential date
550    F = SEQDATE - VAL(WINDOWW$)
560    LSET LASTDATE$ = MKI$(SEQDATE)
570    LSET FIRSTDATE$ = MKI$(F)
580    LSET RAWDATE$ = R$
590    GOTO 680
600 IF FREQ$ <> "Y" THEN PRINT "INCORRECT FREQUENCY IN RECORD "; R : GOTO 690
610    YR = YR + 1                             ' increment year
620    R$ = STR$(MO) + "-" + STR$(DA) + "-" + STR$(YR)
630    D$ = R$ : GOSUB  760                    '  convert to sequential date
640    F = SEQDATE - VAL(WINDOWW$)
650    LSET LASTDATE$ = MKI$(SEQDATE)
660    LSET FIRSTDATE$ = MKI$(F)
670    LSET RAWDATE$ = R$
680 PUT 1,R
690 RETURN
700 '
710 ' ***************************************************************
720 ' ****      SUBROUTINE TO CONVERT DATE TO SEQUENTIAL DATE    ****
730 ' ****         Input = D$    Output = SEQDATE, MO, DA, YR    ****
740 ' ***************************************************************
750 '
760 DATA 0,0,31,59,90,120,151,181,212,243,273,304,334
770 RESTORE
780 FOR I = 0 TO 12
790    READ MDAY(I)
800 NEXT
810 DATERR = 0
820 J = 1
830 FOR I = 1 TO LEN(D$)
840    IF MID$(D$,I,1) = "/" OR MID$(D$,I,1)= "-" THEN DASH(J) =I :J=J+1
850 NEXT I
860 MO = VAL(D$)
870 DA = VAL( MID$ (D$,DASH(1)+1) )
880 YR = VAL( MID$ (D$,DASH(2)+1) )
890 YR$ = RIGHT$(STR$(YR),2)
900 YR  = VAL(YR$)
910 IF MO < 1 OR MO > 12 THEN DATERR = 1       ' DATERR can be used by calling
920 IF DA < 1 OR DA > 31 THEN DATERR = 2       '  routine to initiate various
930 IF YR < 81  THEN DATERR = 3                '  error message routines.
940 INTVAL% = YR -80
950 LEAPYRS% = INTVAL% / 4
960 IF INTVAL%/4 - LEAPYRS% <> 0 THEN GOTO  980   ' branch if not a leapyear
970 IF  MO < 3   THEN LEAPYRS% = LEAPYRS% - 1   'don't add a day until Mar 1
980 SEQDATE = (INTVAL% * 365) + MDAY(MO) + DA
990 RETURN
