                        CWEEP     V2.31a        (update to disk 283)
Author:
        Gary M. Berg
        3707 Silver Oak St.
        Dayton, OH  45424

------------------------------------------------------------------------
Description:
CWEEP V2.31a is a file-manager similar to the CP/M program SWEEP which
lets the user move through a list of files, tag ones to be worked on,
and then copy, delete, or rename them.  It will also allow the user to
view files, make and remove directories. It works on all MS-DOS
machines, even non IBM-compatibles.

------------------------------------------------------------------------
Intended user:
Beginner through advanced

------------------------------------------------------------------------
Improvements:
Compared with V1.30 this version:
  1) Supports subdirectories
  2) Has faster displays (on a PC Compatible)
  3) Can use a user chosen external program to view files
  4) Can display .WKS/WK1 files in a semi-intelligent manner
  5) Can modify file attributes
  6) Can copy files faster since it uses a larger buffer

------------------------------------------------------------------------
Unique features:
A very fast, single keystroke way to work through a directory of
files, copying, viewing, and deleting them.  Works on non-IBM
compatibles.  Has a protected copy feature, which will warn the
user if a file of the same name is about to be over-written.  After
a file is copied, it will (optionally) be re-opened and a CRC done
to verify the copy.

------------------------------------------------------------------------
Capacity limitations:
Will not process more than 750 files in any one directory.

------------------------------------------------------------------------
Requirements:
Requires approximately 192K of free memory to run, and at least one
disk drive.

------------------------------------------------------------------------
To start the program, type:   CWEEP

------------------------------------------------------------------------
Files:
        CWEEP    DSC            This documentation
        CWEEP    EXE    54309   SWEEP-like file manager for MS-DOS
        CWEEP    TXT    38553   Documentation for CWEEP
