* PRNT1040.PRG is used to PRINT the FORM 1040 form.  The printout
* provides the information by Line Number that the taxpayer will
* need to then actually fill in the FORM 1040.  Other forms are
* actually printed by the computer in an acceptable IRS facsimile
* form.  However, the IRS requires that the FORM 1040 be one of
* its forms, or one obtained by a forms vendor.  TAX-FILE assumes
* that you do not want to pay for the FORM 1040; rather you can
* spent the 5 minutes it takes to transfer the numbers from the
* printout provided by TAX-FILE to the "official" IRS FORM 1040.
ERASE
SET TALK OFF
SET EJECT OFF
@ 10,15 SAY "PLACE PAPER IN PRINTER AND TURN PRINTER ON !"
@ 12,15 SAY "   TAP {SPACE BAR} WHEN ALL SET TO PRINT."
SET CONSOLE OFF
WAIT
SET CONSOLE ON
ERASE
@ 10,15 SAY "THE PROGRAM IS ASSEMBLING THE TAX DATA!"
@ 12,15 SAY "HAVE PATIENCE WITH THIS HUMBLE MACHINE."
RESTORE FROM FILEDRIV ADDITIVE
STORE MD1+':'+'PAYRDATA' TO SAVPAYER
RESTORE FROM &SAVPAYER ADDITIVE
RELEASE SAV10401,LINEA,LINEB,SETDRIVE,YRD,SAVPAYER
* SET CONSOLE OFF
* SET PRINT ON
* ? CHR(15)
* SET PRINT OFF
* SET CONSOLE ON
SET FORMAT TO PRINT
@ 1,19 SAY "FORM 1040 - INTERNAL REVENUE SERVICE"
@ 2,19 SAY "***  BASIC TAXPAYER INFORMATION  ***"
@ 4,3 SAY "TAXPAYER"
@ 4,13 SAY MPAYER1
@ 4,45 SAY "SOC. SEC. NO."
@ 4,60 SAY MSSN1
@ 5,3 SAY "SPOUSE"
@ 5,13 SAY MPAYER2
@ 5,45 SAY "SOC. SEC. NO."
@ 5,60 SAY MSSN2
@ 6,3 SAY "ADDRESS"
@ 6,13 SAY MTAXSTRT
@ 7,13 SAY MTAXCITY
@ 7,34 SAY MTAXSTAT
@ 7,45 SAY MTAXZIP
@ 9,3 SAY "TAXPAYER'S OCCUPATION........"
@ 9,33 SAY MPAY1OCU
@ 10,3 SAY "SPOUSE'S OCCUPATION.........."
@ 10,33 SAY MPAY2OCU
@ 12,3 SAY "TAXPAYER TO CONTRIBUTE TO PRESIDENTIAL CAMPAIGN FUND..."
@ 12,58 SAY "."
@ 12,60 SAY MCAMP1
@ 13,3 SAY "SPOUSE TO CONTRIBUTE TO PRESIDENTIAL CAMPAIGN FUND....."
@ 13,58 SAY "."
@ 13,60 SAY MCAMP2
RELEASE ALL EXCEPT RUN
RESTORE FROM FILEDRIV ADDITIVE
STORE MD1+':'+'FRM10401' TO SAV10401
RESTORE FROM &SAV10401 ADDITIVE
RELEASE SAVIT,SAVITD,SAVITID,SAVEXM,FORMSAVE,NEWDAY,
@ 15,25 SAY "***  EXEMPTIONS  ***"
@ 17,3 SAY "NO. FOR TAXPAYER...."
@ 17,24 SAY EXEMP1 USING '9'
@ 17,45 SAY "NO. FOR SPOUSE....."
@ 17,65 SAY EXEMP2 USING '9'
@ 18,3 SAY "NO. FOR CHILDREN...."
@ 18,24 SAY EXEMP3 USING '9'
@ 18,45 SAY "NO. FOR OTHER......"
@ 18,65 SAY EXEMP4 USING '9'
@ 19,3 SAY "NO. FOR OVER 65....."
@ 19,24 SAY EXEMP5 USING '9'
@ 19,39 SAY "TOTAL EXEMPTIONS........"
@ 19,64 SAY EXEMP6 USING '99'
@ 21,18 SAY "***  FORM 1040 TAX INFORMATION  ***"
@ 23,12 SAY "THE FOLLOWING DATA HAVE BEEN COMPUTED BY TAX-FILE"
@ 24,8 SAY "THE AMOUNTS SHOULD BE INSERTED AT LINE NUMBERS INDICATE"
@ 24,63 SAY "D"
@ 26,4 SAY "TOTAL INCOME FROM SALARIES AND WAGES (Line 7).........."
@ 26,59 SAY ".."
@ 26,62 SAY LINE7
@ 27,4 SAY "INTEREST EARNED (Line 8)..............................."
@ 27,59 SAY ".."
@ 27,62 SAY LINE8
@ 28,4 SAY "DIVIDENDS EARNED (Line 9a)............................."
@ 28,59 SAY ".."
@ 28,62 SAY LINE9A
@ 29,6 SAY "EXCLUSION FROM TAX (Line 9b)..........................."
@ 29,62 SAY LINE9B
@ 30,6 SAY "DIVIDENDS TO BE TAXED (Line 9c)........................"
@ 30,62 SAY LINE9C
@ 31,4 SAY "REFUNDS OF STATE AND LOCAL TAXES (Line10).............."
@ 31,59 SAY ".."
@ 31,62 SAY LINE10
@ 32,4 SAY "ALIMONY RECEIVED (Line11).............................."
@ 32,59 SAY ".."
@ 32,62 SAY LINE11
@ 33,4 SAY "BUSINESS INCOME (OR LOSS) (Line 12)...................."
@ 33,59 SAY ".."
@ 33,62 SAY LINE12
@ 34,4 SAY "CAPITAL GAIN (OR LOSS) (Line 13)......................."
@ 34,59 SAY ".."
@ 34,63 SAY LINE13 USING '999999.99'
@ 35,4 SAY "40% OF CAPITAL GAIN DIST. NOT REPORTED LINE 13 (Line 14"
@ 35,59 SAY ")."
@ 35,62 SAY LINE14
@ 36,4 SAY "SUPPLMENTAL GAINS (OR LOSSES) (Line 15)................"
@ 36,59 SAY ".."
@ 36,62 SAY LINE15
@ 37,4 SAY "FULLY TAXABLE PENSIONS, IRA DIST., ANNUITIES (Line 16)."
@ 37,59 SAY ".."
@ 37,62 SAY LINE16
@ 38,4 SAY "OTHER PENSIONS AND ANNUITIES (Line 17a)................"
@ 38,59 SAY ".."
@ 38,62 SAY LINE17A
@ 39,6 SAY "TAXABLE AMOUNT IF ANY (Line 17b)......................."
@ 39,62 SAY LINE17B
@ 40,4 SAY "RENTS, ROYALTIES, PARTNERSHIPS, ESTATES (Line 18)......"
@ 40,59 SAY ".."
@ 40,62 SAY LINE18
@ 41,4 SAY "FARM INCOME (OR LOSS) (Line 19)........................"
@ 41,59 SAY ".."
@ 41,62 SAY LINE19
@ 42,4 SAY "UNEMPLOYMENT COMPENSATION (Line 20a)..................."
@ 42,59 SAY ".."
@ 42,62 SAY LINE20A
@ 43,6 SAY "TAXABLE AMOUNT IF ANY (Line 20b)......................."
@ 43,62 SAY LINE20B
@ 44,4 SAY "SOCIAL SECURITY BENEFITS (Line 21a)...................."
@ 44,59 SAY ".."
@ 44,62 SAY LINE21A
@ 45,6 SAY "TAXABLE AMOUNT IF ANY (Line21b)........................"
@ 45,62 SAY LINE21B
@ 46,4 SAY "OTHER INCOME (Line 22)................................."
@ 46,59 SAY ".."
@ 46,62 SAY LINE22
@ 47,34 SAY "TOTAL INCOME (Line 23)....."
@ 47,63 SAY LINE23 USING '999999.99'
SAVE ALL LIKE SELECT TO MENURUN
RELEASE ALL EXCEPT RUN
RESTORE FROM FILEDRIV ADDITIVE
STORE MD1+':'+'FRM1040A' TO SAVINCO
RESTORE FROM &SAVINCO ADDITIVE
STORE MD1+':'+'LINENUM' TO SAVLINE
RESTORE FROM &SAVLINE ADDITIVE
@ 49,21 SAY "***  ADJUSTMENTS TO INCOME  ***"
@ 51,4 SAY "MOVING EXPENSES (Line 24).............................."
@ 51,59 SAY ".."
@ 51,62 SAY LINE24
@ 52,4 SAY "EMPLOYEE BUSINESS EXPENSES (Line 25)..................."
@ 52,59 SAY ".."
@ 52,62 SAY LINE25
@ 53,4 SAY "IRA DEDUCTION (Line 26a)..............................."
@ 53,59 SAY ".."
@ 53,62 SAY LINE26A
@ 54,6 SAY "IRA PAYMENT MADE IN 1984 FOR 1985 (Line 26b)..........."
@ 54,62 SAY LINE26B
@ 55,4 SAY "PAYMENTS TO KEOGH RETIREMENT PLAN (Line 27)............"
@ 55,59 SAY ".."
@ 55,62 SAY LINE27
@ 56,4 SAY "PENALTY ON EARLY WITHDRAWAL OF SAVINGS (Line 28)......."
@ 56,59 SAY ".."
@ 56,62 SAY LINE28
@ 57,4 SAY "ALIMONY PAID (Line 29)................................."
@ 57,59 SAY ".."
@ 57,62 SAY LINE29
@ 58,4 SAY "DEDUCTION FOR MARRIED COUPLE IF BOTH WORKING (Line 30)."
@ 58,59 SAY ".."
@ 58,62 SAY LINE30
@ 60,29 SAY "TOTAL ADJUSTMENTS (Line 31)....."
@ 60,62 SAY LINE31
@ 62,25 SAY "ADJUSTED GROSS INCOME (Line 32)....."
@ 62,62 SAY LINE32
@ 65,0 SAY "  "
SET FORMAT TO SCREEN
RELEASE ALL EXCEPT RUN
RESTORE FROM FILEDRIV ADDITIVE
STORE MD1+':'+'LINENUM' TO SAVLINE
RESTORE FROM &SAVLINE ADDITIVE
ERASE
@ 10,15 SAY "FIRST SIDE OF FORM 1040 FINISHED PRINTING."
@ 12,15 SAY "      PRESS {RETURN} TO CONTINUE."
SET CONSOLE OFF
WAIT
SET CONSOLE ON
RESTORE FROM FILEDRIV ADDITIVE
STORE MD1+':'+'FRM10402' TO SAV10402
RESTORE FROM &SAV10402 ADDITIVE
STORE LINE32 TO LINE33
SET FORMAT TO PRINT
@ 1,26 SAY "FORM 1040  (REVERSE SIDE)"
@ 3,26 SAY "***  TAX COMPUTATION  ***"
@ 5,4 SAY "AMOUNT FROM LINE 32 (Line 33).........................."
@ 5,59 SAY "."
@ 5,62 SAY LINE33 USING '999999.99'
@ 6,4 SAY "DEDUCTIONS WHERE YOU ITEMIZED (Schedule A) (Line 34a).."
@ 6,59 SAY "."
@ 6,61 SAY LINE34A
@ 7,4 SAY "DEDUCTIONS WHERE YOU DID NOT ITEMIZE (ALLOWABLE"
@ 8,6 SAY "(ALLOWABLE CHARITABLE DEDUCTIONS (Line 34b)..........."
@ 8,61 SAY LINE34B
@ 9,4 SAY "SUBTRACT LINE34a OR 34b (WHICHEVER APPLIES) (Line 35).."
@ 9,59 SAY "."
@ 9,62 SAY LINE35 USING '999999.99'
@ 10,4 SAY "MULTIPLY $1,000 BY TOTAL NUMBER EXEMPTIONS  (Line 36).."
@ 10,59 SAY "."
STORE LINE36/1.00 TO LINE36
@ 10,61 SAY LINE36
@ 11,33 SAY "TAXABLE INCOME (Line 37)..."
@ 11,62 SAY LINE37 USING '999999.99'
@ 12,44 SAY "TAX (Line 38)..."
@ 12,61 SAY LINE38
@ 13,31 SAY "ADDITIONAL TAXES (Line 39)..."
@ 13,61 SAY LINE39
@ 14,35 SAY "SUM OF ABOVE (Line 40)..."
@ 14,61 SAY LINE40
@ 16,28 SAY "***  TAX CREDITS  ***"
@ 18,3 SAY "CREDIT FOR CHILD AND DEPENDENT CARE (Line 41).........."
@ 18,58 SAY ".."
@ 18,61 SAY LINE41
@ 19,3 SAY "CREDIT FOR ELDERLY AND DISABLED (Line 42).............."
@ 19,58 SAY ".."
@ 19,61 SAY LINE42
@ 20,3 SAY "RESIDENTIAL ENERGY (Line 43)..........................."
@ 20,58 SAY ".."
@ 20,61 SAY LINE43
@ 21,3 SAY "PARTIAL CREDIT POLITICAL CONTRIBUTIONS (Line 44)......."
@ 21,58 SAY ".."
@ 21,61 SAY LINE44
@ 22,3 SAY "ADD LINES 41 THROUGH 44 (Line 45)......................"
@ 22,58 SAY ".."
@ 22,61 SAY LINE45
@ 23,3 SAY "SUBTRACT LINE 45 FROM 40 (Line46)......................"
@ 23,58 SAY ".."
@ 23,61 SAY LINE46
@ 24,3 SAY "FOREIGN TAX CREDIT (Line 47)..........................."
@ 24,58 SAY ".."
@ 24,61 SAY LINE47
@ 25,3 SAY "GENERAL BUSINESS CREDIT (Line 48)......................"
@ 25,58 SAY ".."
@ 25,61 SAY LINE48
@ 26,3 SAY "ADD LINES 47 AND 48 (Line 49).........................."
@ 26,58 SAY ".."
@ 26,61 SAY LINE49
@ 27,3 SAY "SUBTRACT LINE 49 FROM 46 (Line 50)....................."
@ 27,58 SAY ".."
@ 27,61 SAY LINE50
@ 29,29 SAY "***  OTHER TAXES  ***"
@ 31,3 SAY "SELF-EMPLOYMENT TAX (Line 51).........................."
@ 31,58 SAY ".."
@ 31,61 SAY LINE51
@ 32,3 SAY "ALTERNATIVE MINIMUM TAX (Line 52)......................"
@ 32,58 SAY ".."
@ 32,61 SAY LINE52
@ 33,3 SAY "TAX FROM RECAPTURE OF INVESTMENT CREDIT (Line 53)......"
@ 33,58 SAY ".."
@ 33,61 SAY LINE53
@ 34,3 SAY "SOCIAL SECURITY TAX ON TIP INCOME (Line 54)............"
@ 34,58 SAY ".."
@ 34,61 SAY LINE54
@ 35,3 SAY "TAX ON IRA (Line 55)..................................."
@ 35,58 SAY ".."
@ 35,61 SAY LINE55
@ 36,3 SAY "ADD LINES 50 THROUGH 55. THIS IS TOTAL TAX (Line 56)..."
@ 36,58 SAY ".."
@ 36,61 SAY LINE56
@ 38,27 SAY "***  PAYMENTS MADE  ***"
@ 40,3 SAY "FEDERAL INCOME TAX WITHHELD (Line 57).................."
@ 40,58 SAY ".."
@ 40,61 SAY LINE57
@ 41,3 SAY "1984 ESTIMATED TAX PAYMENTS (Line 58).................."
@ 41,58 SAY ".."
@ 41,62 SAY LINE58 USING '999999.99'
@ 42,3 SAY "EARNED INCOME CREDIT (Line 59)........................."
@ 42,58 SAY ".."
@ 42,61 SAY LINE59
@ 43,3 SAY "AMOUNT PAID WITH FORM 4868 (Line 60)..................."
@ 43,58 SAY ".."
@ 43,61 SAY LINE60
@ 44,3 SAY "EXCESS SOCIAL SECURITY TAX AND RRTA TAX (Line 61)......"
@ 44,58 SAY ".."
@ 44,61 SAY LINE61
@ 45,3 SAY "CREDIT FOR FEDERAL TAX ON GASOLINE (Line 62)..........."
@ 45,58 SAY ".."
@ 45,61 SAY LINE62
@ 46,3 SAY "REGULATED INVESTMENT COMPANY CREDIT (Line 63).........."
@ 46,58 SAY ".."
@ 46,61 SAY LINE63
@ 47,3 SAY "ADD LINES 57 THROUGH 63.  TOTAL PAYMENT (Line 64)......"
@ 47,58 SAY ".."
@ 47,61 SAY LINE64
@ 49,23 SAY "*** REFUND or AMOUNT OWED  ***"
@ 51,3 SAY "IF LINE 64 IS LARGER THAN LINE 56 (Line 65)............"
@ 51,58 SAY ".."
@ 51,61 SAY LINE65
STORE LINE65 TO LINE66
@ 52,3 SAY "AMOUNT TO BE REFUNDED TO YOU (Line 66)................."
@ 52,58 SAY ".."
@ 52,61 SAY LINE66
@ 53,3 SAY "AMOUNT ON LINE 65 TO APPLY TO 1985 TAX (Line 67)......."
@ 53,58 SAY ".."
@ 53,61 SAY LINE67
@ 54,3 SAY "IF LINE 56 IS LARGER THAN LINE 64 (Line 68), THIS IS"
@ 55,6 SAY "AMOUNT YOU OWE.  ATTACH CHECK OR MONEY ORDER!........."
@ 55,61 SAY LINE68
@ 59,3 SAY "               ************  ALL FINISHED  ************"
@ 66,0 SAY "  "
SET FORMAT TO SCREEN
ERASE
@ 10,15 SAY "SECOND SIDE OF FORM 1040 FINISHED PRINTING."
@ 12,15 SAY "       PRESS {RETURN} TO CONTINUE."
SET CONSOLE OFF
WAIT
SET CONSOLE ON
RELEASE ALL EXCEPT RUN
RESTORE FROM MENURUN ADDITIVE
STORE DATE() TO NEWDAY
RETURN
