* PRNTSCHB.PRG is used to print the data for SCHEDULE B.
ERASE
@ 07,10 SAY "PATIENCE WHILE TEMPORARY FILES ARE CREATED TO PRINT SCHEDULE B"
*  RESTORES THE DRIVE DESIGNATED, THE TAXPAYER DATA, AND THE SCHEDULE B
*  DATA PREVIOUSLY COMPUTED
RESTORE FROM FILEDRIV ADDITIVE
STORE MD1+':'+'FORMB' TO FORMFILE
RESTORE FROM &FORMFILE ADDITIVE
STORE MD1+':'+'PAYRDATA' TO PAYRFILE
RESTORE FROM &PAYRFILE ADDITIVE
STORE MD1+':'+'INCOME' TO NEWFILE
USE &NEWFILE
*  CREATES TEMPORARY FILES FOR THE PRINTING OF INTEREST AND DIVIDEND DATA.
STORE MD1+':'+'INTRFILE' TO TFILE1
COPY TO &TFILE1 FOR TYPE = 'INTE'
USE &TFILE1
STORE MD1+':'+'INTR' TO INTINX
INDEX ON SOURCE TO &INTINX
USE &NEWFILE
STORE MD1+':'+'DIVIFILE' TO TFILE2
COPY TO &TFILE2 FOR TYPE = 'DIVI'
USE &TFILE2
STORE MD1+':'+'DIVI' TO DIVINX
INDEX ON SOURCE TO &DIVINX
@ 10,22 SAY "BE SURE YOUR PRINTER IS TURNED ON."
@ 12,22 SAY "PRESS {RETURN} WHEN SET TO PRINT."
@ 20,0 SAY "  "
WAIT
ERASE
@ 10,14 SAY "PATIENCE...THE COMPUTER WILL START PRINTING IN A MOMENT."
USE &TFILE1 INDEX &INTINX
SET FORMAT TO PRINT
DO WHILE .NOT. EOF
  @ 1,1 SAY "STATEMENT TO ATTACH TO SCHEDULE B"
  @ 1,51 SAY "INTEREST AND DIVIDEND INCOME"
  @ 2,1 SAY "--------------------------------------------------"
  @ 2,51 SAY "----------------------------"
  @ 3,1 SAY "NAME "
  @ 3,6 SAY TRIM(MPAYER1)
  @ 3,60 SAY "SSN"
  @ 3,64 SAY MSSN1
  @ 4,1 SAY "--------------------------------------------------"
  @ 4,51 SAY "----------------------------"
  @ 5,1 SAY "---- INTEREST FROM SELLER FINANCED MORTGAGE ------"
  @ 6,1 SAY "     NAME OF PAYER"
  @ 6,62 SAY "AMOUNT"
  @ 7,6 SAY SELLER
  @ 7,59 SAY ILINE1 USING '999999.99'
  @ 8,1 SAY "--------------------------------------------------"
  @ 8,51 SAY "----------------------------"
  @ 9,1 SAY "---- INTEREST FROM OTHER SOURCES ------"
  @ 10,1 SAY "     NAME OF PAYER"
  @ 10,62 SAY "AMOUNT"
  STORE 11 TO CTR
  DO WHILE CTR <21 .AND. .NOT. EOF
    @ CTR,6 SAY SOURCE
    @ CTR,59 SAY AMT USING '999999.99'
    STORE CTR + 1 TO CTR
    SKIP
  ENDDO
  @ 22,1 SAY "     TOTAL ...TO SCHEDULE B, LINE 2 ................. "
  @ 22,59 SAY ILINE2 USING '999999.99'
  @ 23,1 SAY "--------------------------------------------------"
  @ 23,51 SAY "----------------------------"
  USE &TFILE2 INDEX &DIVINX
  @ 24,1 SAY "---- DIVIDEND INCOME ------"
  @ 25,1 SAY "     NAME OF PAYER"
  @ 25,62 SAY "AMOUNT"
  STORE 26 TO LCTR
  DO WHILE LCTR <36 .AND. .NOT. EOF
    @ LCTR,6 SAY SOURCE
    @ LCTR,59 SAY AMT USING '999999.99'
    STORE LCTR + 1 TO LCTR
    SKIP
  ENDDO
  @ 36,1 SAY "     TOTAL ...TO SCHEDULE B, LINE 4 ................. "
  @ 36,59 SAY DLINE5 USING '999999.99'
  @ 37,1 SAY "--------------------------------------------------"
  @ 37,51 SAY "----------------------------"
  @ 39,08 SAY "CAPITAL GAINS DISTRIBUTIONS..................... "
  @ 39,59 SAY DLINE6 USING '999999.99'
  @ 40,08 SAY "NON-TAXABLE DISTRIBUTIONS....................... "
  @ 40,59 SAY DLINE7 USING '999999.99'
  @ 41,08 SAY "EXCLUSION OF QUALIFIED REINVESTMENT DIVIDENDS... "
  @ 41,59 SAY DLINE8 USING '999999.99'
  STORE DLINE6 + DLINE7 + DLINE8 TO DLINE9
  STORE (DLINE5)-(DLINE9) TO DLINE10
  @ 43,08 SAY "           SUM of lines 6, 7, and 8............. "
  @ 43,59 SAY DLINE9 USING '999999.99'
  @ 44,08 SAY "                   TOTAL TAXABLE DIVIDENDS...... "
  @ 44,59 SAY DLINE10 USING '999999.99'
  @ 45,1 SAY "--------------------------------------------------"
  @ 45,51 SAY "----------------------------"
  @ 66,0 SAY "  "
  SET FORMAT TO SCREEN
ENDDO
ERASE
STORE 0 TO DELAY
@ 10,15 SAY "RETURNING TO THE MAIN MENU...SCHEDULE B IS FINISHED."
DO WHILE DELAY < 25
  STORE DELAY + 1 TO DELAY
ENDDO
RELEASE ALL EXCEPT RUN
STORE DATE() TO NEWDAY
RETURN
