* TAXCOMPU.PRG is used to compute your FEDERAL TAXES up to the point
* of the Tax Table currently in effect.  Once the TAXABLE INCOME less
* deductions is known, you can refer to the current Tax Table to confirm
* the actual taxes owed.  The program then takes you further through
* the computation of Tax Credits, other taxes paid, and previous Tax
* payments.  The result is a sum of the REFUND OWED or ADDITIONAL TAXES
* OWED to Uncle Sam.
SET TALK OFF
SET COLON OFF
ERASE
RESTORE FROM FILEDRIV ADDITIVE
STORE MD1+':'+'EXEMPT' TO SAVEM
RESTORE FROM &SAVEM ADDITIVE
STORE MD1+':'+'DEDCTOT' TO SAVDED
RESTORE FROM &SAVDED ADDITIVE
STORE MD1+':'+'LINENUM' TO SAVIT
RESTORE FROM &SAVIT ADDITIVE
RELEASE SAVIT,SAVDED
STORE LINE32 TO LINE33
STORE LINE26 TO LINE34A
STORE 000000.00 TO LINE34B
STORE 000000.00 TO LINE35
STORE 000000.00 TO LINE36
STORE 000000.00 TO LINE37
STORE 000000.00 TO LINE38
STORE 000000.00 TO LINE39
STORE 000000.00 TO LINE40
STORE 000000.00 TO LINE41
STORE 000000.00 TO LINE42
STORE 000000.00 TO LINE43
STORE 000000.00 TO LINE44
STORE 000000.00 TO LINE45
STORE 000000.00 TO LINE46
STORE 000000.00 TO LINE47
STORE 000000.00 TO LINE48
STORE 000000.00 TO LINE49
STORE 000000.00 TO LINE50
STORE 000000.00 TO LINE51
STORE 000000.00 TO LINE52
STORE 000000.00 TO LINE53
STORE 000000.00 TO LINE54
STORE 000000.00 TO LINE55
STORE 000000.00 TO LINE56
STORE 000000.00 TO LINE57
STORE 000000.00 TO LINE58
STORE 000000.00 TO LINE59
STORE 000000.00 TO LINE60
STORE 000000.00 TO LINE61
STORE 000000.00 TO LINE62
STORE 000000.00 TO LINE63
STORE 000000.00 TO LINE64
STORE 000000.00 TO LINE65
STORE 000000.00 TO LINE66
STORE 000000.00 TO LINE67
STORE 000000.00 TO LINE68
STORE 000000.00 TO LINE69
* ====== COMPUTE FEDERAL TAXES OWED BEFORE CREDITS
@ 1,23 SAY "FEDERAL INCOME TAX COMPUTATION"
@ 3,2 SAY "      Amount of ADJUSTED GROSS INCOME from line 32"
@ 3,57 GET LINE33
@ 5,2 SAY "Sum of ITEMIZED DEDUCTIONS from Schedule A line 26"
@ 5,57 GET LINE34A
CLEAR GETS
IF LINE34A = 0
@ 7,2 SAY "If deductions not itemized, and you have CHARITABLE"
@ 8,5 SAY "DEDUCTIONS, enter amount here."
@ 8,57 GET LINE34B
READ
STORE LINE33-LINE34B TO LINE35
ELSE
STORE LINE33-LINE34A TO LINE35
@ 10,12 SAY "    ADJUSTED GROSS INCOME less DEDUCTIONS"
@ 10,57 GET LINE35
@ 12,12 SAY "$1,000 multiplied by number of EXEMPTIONS"
@ 13,19 SAY "from FORM 1040 line 6"
STORE (EXEMP6)*1000 TO LINE36
@ 13,57 GET LINE36
@ 15,39 SAY "TAXABLE INCOME"
STORE LINE35-LINE36 TO LINE37
@ 15,57 GET LINE37
CLEAR GETS
@ 17,3 SAY " Check TAX TABLE, TAX RATE SCHEDULE, or SCHEDULE G"
@ 18,6 SAY "     Enter the amount of taxes owed here "
SET COLOR TO 1,143
@ 18,53 SAY ">>>"
SET COLOR TO 112,7
@ 18,57 GET LINE38
READ
@ 19,3 SAY "   Additional taxes from forms 4970, 4972, or 5544"
@ 19,57 GET LINE39
READ
STORE LINE38 + LINE39 TO LINE40
@ 20,35 SAY "SUM OF ABOVE TAXES"
@ 20,57 GET LINE40
@ 23,24 SAY "PRESS {RETURN} TO CONTINUE."
ENDIF
SET CONSOLE OFF
WAIT
SET CONSOLE ON
ERASE
* ===== COMPUTE CREDITS
@ 2,30 SAY "TAX CREDITS"
@ 4,6 SAY "Credit for child and dependent care"
@ 4,59 GET LINE41
@ 5,6 SAY "Credit for elderly and permanently disabled"
@ 5,59 GET LINE42
@ 6,6 SAY "Residential Energy Credit from Form 5695)"
@ 6,59 GET LINE43
@ 7,6 SAY "Partial credit for Political Contributions"
@ 7,59 GET LINE44
READ
STORE LINE41 + LINE42 + LINE43 + LINE44 TO LINE45
@ 9,26 SAY "TOTAL PERSONAL TAX CREDITS"
@ 9,59 GET LINE45
@ 11,26 SAY "Line 40 less Line 45"
STORE LINE40-LINE45 TO LINE46
@ 11,59 GET LINE46
CLEAR GETS
@ 13,6 SAY "Foreign tax credit from Form 1116"
@ 13,59 GET LINE47
@ 14,6 SAY "General business credit from Form 3800, 3468,"
@ 15,37 SAY "5884, or 6478."
@ 15,59 GET LINE48
READ
STORE LINE47 + LINE48 TO LINE49
@ 17,20 SAY "TOTAL BUSINESS AND OTHER CREDITS"
@ 17,59 GET LINE49
STORE LINE46-LINE49 TO LINE50
@ 19,39 SAY "TOTAL CREDITS"
@ 19,59 GET LINE50
@ 21,23 SAY "PRESS {RETURN} TO CONTINUE."
CLEAR GETS
SET CONSOLE OFF
WAIT
SET CONSOLE ON
ERASE
* =======  COMPUTE OTHER TAXES
@ 3,27 SAY "OTHER TAXES PAID"
@ 5,5 SAY "Self-employment tax from Schedule SE"
@ 5,58 GET LINE51
@ 6,5 SAY "Alternative minimum tax from Form 6251"
@ 6,58 GET LINE52
@ 7,5 SAY "Tax from recaputure of investment credit"
@ 8,29 SAY "from Form 4255"
@ 8,58 GET LINE53
@ 9,5 SAY "Social Security tax on tip income"
@ 10,7 SAY "not reported to employer from Form 4137"
@ 10,58 GET LINE54
@ 11,5 SAY "Tax on an IRA from Form 5329"
@ 11,58 GET LINE55
READ
STORE 000000.00 TO LINE55A
STORE LINE51 + LINE52 + LINE53 + LINE54 + LINE55 TO LINE55A
STORE LINE50 + LINE55A TO LINE56
@ 13,30 SAY "TOTAL OTHER TAXES PAID"
@ 13,58 GET LINE55A
@ 15,30 SAY "TOTAL TAXES PAID"
@ 15,58 GET LINE56
@ 18,23 SAY "PRESS {RETURN} TO CONTINUE."
CLEAR GETS
SET CONSOLE OFF
WAIT
SET CONSOLE ON
ERASE
* =======  COMPUTE TAX PAYMENTS
@ 2,22 SAY "PAYMENTS OF FEDERAL TAXES"
@ 4,2 SAY "Federal income tax withheld .........................."
@ 4,58 GET LINE57
@ 6,2 SAY "1984 Estimated tax payments and amount applied"
@ 7,30 SAY "from 1983 return.........."
@ 7,58 GET LINE58
@ 9,2 SAY "Earned income credit if line 33 under $10,000........."
@ 9,58 GET LINE59
@ 11,2 SAY "Amount paid with Form 4868............................"
@ 11,58 GET LINE60
@ 13,2 SAY "Excess social security tax and RRTA tax withheld......"
@ 13,58 GET LINE61
@ 15,2 SAY "Credit for Federal tax on gasoline and special"
@ 16,26 SAY "fuels from Form 4136.........."
@ 16,58 GET LINE62
@ 18,2 SAY "Regulated Investment Co. credit from Form 2439........"
@ 18,58 GET LINE63
READ
STORE LINE57 + LINE58 + LINE59 + LINE60 + LINE61 +;
  LINE62 + LINE63 TO LINE64
@ 20,30 SAY "TOTAL TAX PAYMENTS........"
@ 20,58 GET LINE64
@ 22,21 SAY "PRESS {RETURN} TO CONTINUE."
CLEAR GETS
SET CONSOLE OFF
WAIT
SET CONSOLE ON
ERASE
* =======  COMPUTE REFUND DUE or ADDITIONAL TAXES DUE
@ 08,15 SAY "REFUND DUE OR AMOUNT OWED IN ADDITIONAL TAX"
@ 09,15 SAY "*******************************************"
STORE (LINE64)-(LINE56) TO LINETAX
IF LINETAX >= 0
STORE LINETAX TO LINE65
@ 12,12 SAY "                AMOUNT DUE AS REFUND " GET LINE65
CLEAR GETS
@ 14,12 SAY "AMOUNT TO APPLY TO NEXT YEAR'S TAXES " GET LINE67
READ
STORE LINE65-LINE67 TO LINE66
@ 16,12 SAY "        AMOUNT TO BE REFUNDED TO YOU " GET LINE66
@ 18,12 SAY "        PRESS {RETURN} TO CONTINUE."
SET CONSOLE OFF
WAIT
SET CONSOLE ON
ERASE
ENDIF
IF LINETAX < 0
STORE (LINETAX)*(-1) TO LINE68
@ 12,14 SAY "    AMOUNT YOU OWE IN TAXES  "GET LINE68
@ 14,14 SAY "        PRESS {RETURN} TO CONTINUE."
CLEAR GETS
SET CONSOLE OFF
WAIT
SET CONSOLE ON
ERASE
ENDIF
STORE MD1+':'+'FRM10402' TO SAV10402
SAVE TO &SAV10402
RELEASE ALL EXCEPT RUN
RESTORE FROM SELECT ADDITIVE
STORE DATE() TO NEWDAY
RETURN
