* TAXFORM.PRG is used to display and print FORM 1040 and SCHEDULE A & B
* and FORM 2106 (BUSINESS DEDUCTIONS).  It also can generate SCHEDULE D
* DATA.
* SCHED_A.PRG DOES THE SCHEDULE A DATA.  IT ASSUMES YOU HAVE ADDED
* UP INCOME AND COMPUTED BUSINESS EXPENSES FIRST.  THUS, FORM 2106
* MUST FIRST BE DONE TO GET ADJUSTED GROSS INCOME.  ALSO FORM 1040
* SHOULD BE RUN TO TOTAL INCOME AND ADJUSTMENTS TO GET ADJUSTED
* GROSS INCOME.  THAT IS NEEDED TO COMPUTE FIGURES FOR MEDICAL
* DEDUCTIONS IN SCHEDULE A.
SET TALK OFF
SET CONFIRM ON
STORE ' ' TO SELECT
@ 02,23 SAY "*****  INTERNAL REVENUE SERVICE  *****"
@ 03,23 SAY "    TAX FORMS and TAX COMPUTATION"
@ 04,23 SAY "           *****************"
SET COLOR TO 1,143
@ 06,23 SAY "==>>"
SET COLOR TO 112,7
@ 06,29 SAY "RUN REPORTS IN LISTED ORDER"
@ 08,23 SAY "1)  SCHEDULE D (CAPITAL GAINS/LOSSES)"
@ 09,23 SAY "2)  SCHEDULE B (DIVIDENDS and INTEREST)"
@ 10,23 SAY "3)  FORM 2106 (BUSINESS EXPENSES)"
@ 11,23 SAY "4)  FORM 1040 (INCOME AND ADJUSTMENTS)"
@ 12,23 SAY "5)  SCHEDULE A (ITEMIZED DEDUCTIONS)"
@ 14,23 SAY "6)  TAXPAYER INFORMATION"
@ 16,23 SAY "7)  COMPUTE TAXES (UGH!)"
@ 17,23 SAY "8)  PRINT TAX FORMS"
@ 19,23 SAY "9)  EXIT THIS MENU"
@ 21,23 SAY "         MAKE SELECTION " GET SELECT
READ
ERASE
DO CASE
  CASE SELECT = '1'
    ERASE
    DO BONDSTOK
    ERASE
  CASE SELECT = '2'
    ERASE
    DO SCHED_B
    ERASE
  CASE SELECT = '3'
    ERASE
    DO FORM2106
    ERASE
  CASE SELECT = '4'
    ERASE
    DO FORM1040
    ERASE
  CASE SELECT = '5'
    ERASE
    DO SCHED_A
    ERASE
  CASE SELECT = '6'
    ERASE
    STORE '                              ' TO MPAYER1
    STORE '   -  -    ' TO MSSN1
    STORE '                              ' TO MPAYER2
    STORE '   -  -    ' TO MSSN2
    STORE '                              ' TO MTAXSTRT
    STORE '                    ' TO MTAXCITY
    STORE '  ' TO MTAXSTAT
    STORE '     ' TO MTAXZIP
    STORE '                              ' TO MPAY1OCU
    STORE '                              ' TO MPAY2OCU
    STORE ' ' TO MCAMP1
    STORE ' ' TO MCAMP2
    @ 04,01 SAY "           INFORMATION ON TAXPAYER(S) FOR USE WITH FORM 1040"
    @ 06,02 SAY "FULL NAME OF TAXPAYER " GET MPAYER1
    @ 07,04 SAY "SOCIAL SECURITY NUMBER " GET MSSN1 PICT '999-99-9999'
    @ 09,02 SAY "FULL NAME OF SPOUSE (IF ANY) " GET MPAYER2
    @ 10,04 SAY "SOCIAL SECURITY NUMBER " GET MSSN2 PICT '999-99-9999'
    @ 12,02 SAY "ADDRESS OF TAXPAYER "
    @ 13,02 SAY " STREET " GET MTAXSTRT
    @ 14,02 SAY " CITY "GET MTAXCITY
    @ 14,38 SAY " STATE "GET MTAXSTAT PICT 'AA'
    @ 14,50 SAY " ZIP " GET MTAXZIP PICT '99999'
    @ 16,02 SAY "OCCUPATION OF TAXPAYER " GET MPAY1OCU
    @ 17,02 SAY "OCCUPATION OF SPOUSE   " GET MPAY2OCU
    @ 19,02 SAY "TAXPAYER DESIGNATES $1.00 TO PRESIDENTIAL FUND (Y/N)? "
    @ 19,56 GET MCAMP1 PICT 'A'
    @ 20,02 SAY "  SPOUSE DESIGNATES $1.00 TO PRESIDENTIAL FUND (Y/N)? "
    @ 20,56 GET MCAMP2 PICT 'A'
    @ 22,22 SAY "PRESS {RETURN} TO FINISH."
    READ
    ERASE
    SAVE ALL LIKE M* TO PAYRDATA
    RELEASE ALL LIKE M*
  CASE SELECT = '7'
    ERASE
    DO TAXCOMPU
    ERASE
  CASE SELECT = '8'
    ERASE
    DO PRNTFORM
    ERASE
  CASE SELECT = '9'
    ERASE
    RETURN
ENDCASE
RELEASE SELECT
RETURN
